/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package LEONBIS;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

/**
 *
 * @author legrand
 */
public class LEONBIS
{

    private static ReadAlignment ReadAlignment;
    static Bscore bscore;
    //static ArrayList<ArrayList> precision;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {//throws IOException {

   
        String fileAlignment = "";
        String filecluspack = "";
        String fileDichletMixture = null;
        Boolean PrintScores = false;
        Boolean cluspack = true;
        String filexml = "";
        String nameAlignment = "";
        double factor = 1.0;



        if (args.length == 0) {
            printHelp();
            return;

        }


        for (int i = 0; i < args.length; i++) {
            if ("-file".equals(args[i])) {
                fileAlignment = args[i + 1];
            } else if ("-dirichlet".equals(args[i])) {
                fileDichletMixture = args[i + 1];
            } else if ("-help".equals(args[i])) {
                printHelp();
                return;
            } else if ("-scores".equals(args[i])) {
                PrintScores = true;
            } else if ("-clu".equals(args[i])) {
                filecluspack = args[i + 1];
            } else if ("-xml".equals(args[i])) {
                filexml = args[i + 1];
            } else if ("-factor".equals(args[i])) {
                factor = Double.parseDouble(args[i + 1]);
            }

        }
        
        //Read the alignment 
        ReadAlignment = new ReadAlignment(fileAlignment, nameAlignment);

        //Read the cluspack file:
        if (cluspack == true) {
            readcluspack groups = new readcluspack(filecluspack, ReadAlignment);
            groups.AddGroup();
            // ReadAlignment.PrintSequence();
            for (int n = 0; n < groups.numCluster + 1; n++) {
                //System.out.println("cluster:"+n);

                bscore = new Bscore(ReadAlignment, fileDichletMixture, n);
                
                // for each cluster, calculate sequence weights 
                bscore.sequenceWeights(n);
                
                // calculate BILD column scores
                ArrayList columnscores = bscore.scoreColumns();
                //System.out.println("columns ");
                
                // sliding window averages, window length = 5 
                ArrayList windowscores = bscore.scoreWindows(columnscores, 2, n);
                //System.out.println("windows "+n+" ");
                                
                // calculate core blocks
                ArrayList<int[]> coreblocks = bscore.coreblocks(windowscores, columnscores, n);
                
                //save the coreblocks
                ReadAlignment.addgroupcoreblock(coreblocks, n);


                //on les affiches 
                /*for (int[] b : coreblocks) {
                    System.out.println("CB "+b[0] + " " + b[1]);
                }*/

            }

            
            bscore.checkcoreblock(factor);
            
            coreblocktoxml cxml = new coreblocktoxml(ReadAlignment, filexml);
            cxml.generatexml();
            
            System.exit(0);
        }







        //otherwise use a single group
        if (cluspack == false) {
            bscore = new Bscore(ReadAlignment, fileDichletMixture, 0);
            ArrayList scoreAlignment = bscore.scoreColumns();

            if (PrintScores) {
                System.out.println(scoreAlignment.toString());
            }



            /* for (int[] b:scorewindows){
            System.out.println(b[0]+" "+b[1]);
            
            }
             */


        }

    }

    /**
     * show help
     */
    static void printHelp() {
        System.out.println("Enter the options:");
        System.out.println("required:");
        System.out.println("-file <file containing the alignment> ");
        System.out.println("-clu <cluspack file>");
        System.out.println("-xml <output xml file>");
        System.out.println("-name <name_of_alignment>");
        System.out.println("-query <query>");
        
        
        
        System.out.println("optional:");
        System.out.println("-dirichlet <dirichlet file> #recod3.20.comp by default");
        System.out.println("-cutofmin <cutofmin> # 0.2 by default");

     

    }
}
