/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package SDR;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author legrand
 */

/*Permet de lire un allignement de sequence fasta sous la forme d'une arraylist de sequence */
public class ReadAlignment {

    String file;
    ArrayList<Sequence> sequenceArray;
    boolean bname;
    String name;
    String sequenceQuery;
    ArrayList <groupcoreblock> coreblocks;

    public ReadAlignment(String file,String name) {
        this.file = file;
        sequenceArray = new ArrayList();
        this.name=name;
        this.sequenceQuery="";
        coreblocks=new ArrayList<groupcoreblock>();
        fastaormsf();
        
        // code gaps at the beginning and end of the sequences with the "." character, otherwise gaps are "-"
        codeterminalgaps();
    }

    String codeterminalgaps() {
        String c;

        for (Sequence seq:sequenceArray){
            int sizesequence = (seq.Seq).size();
            for (int i = 1; i < sizesequence; i++) {
                c = ((seq).Seq).get(i); 
                if (("-").equals(c) || (".").equals(c)){
                    (seq.Seq).set(i,".");
                } 
                else break;
            }
            for (int i = sizesequence-1; i >= 0; i--) {
                c = ((seq).Seq).get(i); 
                if (("-").equals(c) || (".").equals(c)){
                    (seq.Seq).set(i,".");
                } 
                else break;
            }
        }
        return null;
    }
    
    
    
    String fastaormsf(){
           boolean endOfFile = false;
        try {
            int count=0;
            FileReader fileAlignment = new FileReader(file);
            BufferedReader fileBuffer = new BufferedReader(fileAlignment);
            while (!endOfFile) {
                String fileLine = fileBuffer.readLine();
                if (fileLine == null) {
                    endOfFile = true;
                } else {
                    String[] fileLineArray = fileLine.split("");
                    try {//cas ou fileLineArray[1] n'existe pas
                        count++;
                        if (count>5){
                            msfToSequence();
                            //System.out.println("msf");
                            return null;
                        }
                        if ((">").equals(fileLineArray[1])) {
                            fastaToSequence();
                            //System.out.println("fasta");
                            return null;
                        } 
                    } catch (Exception e) {
                    }
                }
            }
            fileBuffer.close();
        } catch (IOException e) {
            System.out.println("ERREUR lecture fichier alignment");
        }
        return null;
}
    
    
    /**
     * fichier fasta convertie en sequence *
     */
    void fastaToSequence() {
        boolean endOfFile = false;
        try {
            FileReader fileAlignment = new FileReader(file);
            BufferedReader fileBuffer = new BufferedReader(fileAlignment);
            while (!endOfFile) {
                String fileLine = fileBuffer.readLine();
                if (fileLine == null) {
                    endOfFile = true;
                } else {
                    String[] fileLineArray = fileLine.split("");
                    try {//cas ou fileLineArray[1] n'existe pas
                        if ((">").equals(fileLineArray[1])) {
                            String nomSequence = "";
                            for (int i = 2; i < fileLineArray.length; i++) {
                                nomSequence += fileLineArray[i];
                            }
                            sequenceArray.add(new Sequence(nomSequence));
                        } else if (!" ".equals(fileLineArray[1])) {
                            for (int i = 1; i < fileLineArray.length; i++) {
                                Sequence lastSequence = (Sequence) sequenceArray.get(sequenceArray.size() - 1);
                                lastSequence.AddResidu((String) (fileLineArray[i]).toUpperCase());
                            }
                        }
                    } catch (Exception e) {
                    }
                }
            }
            fileBuffer.close();
        } catch (IOException e) {
            System.out.println("ERROR reading file Fasta");
        }
    }

    /**
     * fichier msf convertie en sequence *
     */
    void msfToSequence() {
        boolean endOfFile = false;
        try {
            FileReader fileAlignment = new FileReader(file);
            BufferedReader fileBuffer = new BufferedReader(fileAlignment);
            while (!endOfFile) {
                String fileLine = fileBuffer.readLine();
                if (fileLine == null) {
                    endOfFile = true;
                } else {
                    String[] fileLineArray = fileLine.split(" ");

                    try {
                        if ("Name:".equals(fileLineArray[1])) {
                            sequenceArray.add(new Sequence(fileLineArray[2]));
                        }
                        for (int i = 0; i < sequenceArray.size(); i++) {
                            if (sequenceArray.get(i).Name.equals(fileLineArray[0])) {
                                for (int x = 1; x < fileLineArray.length; x++) {
                                    String[] residu = fileLineArray[x].split("");
                                    for (int z = 0; z < residu.length; z++) {
                                        if (residu[z].length() == 1) {
                                            sequenceArray.get(i).AddResidu(residu[z]);
                                        }
                                    }
                                }
                            }
                        }
                    } catch (Exception e) {
                    }
                }
            }
            fileBuffer.close();
        } catch (IOException e) {
            System.out.println("ERROR reading file MSF");
        }

    }

  

    
    /**
     * renvois le nom de  l'allignement pas teste
     * @return 
     */
    String nameofalignment(){
        String name=file;
        Pattern pattern = Pattern.compile(".*/(.*)(#|$)");
        Matcher matcher = pattern.matcher(name);
        if (matcher.find())
        {
            
            name=matcher.group(1);
          
        }
        //on enleve l'extention
       if (name.indexOf(".") > 0){
             name = name.substring(0, name.lastIndexOf("."));
       } 
        
        return "\""+file+"\"";
    }
    
    
    
     String nameofalignement(){
         return name;
     }
    /**
     * Cherche si la sequence existe et lui assigne un groupe
     */
    void AddClusterToSequence(String nomsequence, int numCluster){
        //System.out.println("test");
        for (int i = 0; i < sequenceArray.size()+1; i++) {
           // System.out.println("test");
            if (sequenceArray.get(i).Name.equals(nomsequence)){
                sequenceArray.get(i).AddCluster(numCluster);
               return;
            }
        }
    }
    
    void addgroupcoreblock (ArrayList <int[]> coreblock, int cluster){
        groupcoreblock gb=new groupcoreblock(cluster, coreblock);
        coreblocks.add(gb);
    }

   
}
