#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <math.h>
#include "leon.h"

#define MIN(a,b) ((a)<(b)?(a):(b))
#define MAX(a,b) ((a)>(b)?(a):(b))



GROUP *groups;
sint ngroups;
ALN mult_aln;

int main(int argc,char **argv)
{
	sint i,j,k,n,s,ix;
	char c;
	char infile[FILENAMELEN+1];
	char outfile[FILENAMELEN+1];
	FILE *ofd;
	OPT opt;

	if(argc!=3) {
		fprintf(stdout,"Usage: %s input_aln outfile\n",argv[0]);
		exit(1);
	}

	strcpy(infile,argv[1]);
	strcpy(outfile,argv[2]);


        init_options(&opt);

        (*opt.alnout_opt).output_clustal=FALSE;
        (*opt.alnout_opt).output_relacs=TRUE;

/* read in the sequences */
	seq_input(infile,opt.explicit_type,FALSE,&mult_aln);
	if(mult_aln.nseqs<=0) {
		error("No sequences in %s\n",infile);
		exit(1);
	}

/* write out the sequences in cluster order */
	ix=n=0;
        for (i=0;i<mult_aln.nseqs;i++) {
		if(mult_aln.seqs[i].simgroup>n) n=mult_aln.seqs[i].simgroup;
	}
        strcpy((*opt.alnout_opt).relacs_outname, outfile);
	for(j=0;j<=n;j++) {
        	for (i=0;i<mult_aln.nseqs;i++) 
			if(mult_aln.seqs[i].simgroup==j) mult_aln.seqs[i].output_index = ix++;
	}


        if(!open_alignment_output(infile,opt.alnout_opt)) exit(1);
        create_alignment_output(mult_aln,*opt.alnout_opt);
        fprintf(stdout,"\n");

	exit(0);

}
 


