#!/bin/tcsh


if ( $# != 2 ) then
echo "Usage:probe.tcsh input_file output_file"
exit 1
endif

# You may need to edit these lines to point to cluspack and chain_blocks PATH.

setenv LEON1PATH ./leon_src
setenv CLUSPACKPATH ./cluspack_src

# convert input alignment to suitable format for external programs
$LEON1PATH/convseq $1 $$.tfa fasta

#launch cluspack
$CLUSPACKPATH/cluspack $$.tfa -dt=alignment -cm=bionj -nbc=secator -fd=0.01 -oclu=$$.clu
$LEON1PATH/readclusters $$.tfa $$.clu > $$.clu1

#launch leon-bis.jar
java -jar LEON_BIS.jar -file $$.tfa -clu $$.clu1 -xml $$.xml  > $$.log

#reorder the sequences
$LEON1PATH/clustseq $$.xml $2


\rm $$*
exit 0



